# Project Name

Comprehensive XML generator for Python

## Table of Contents

- [Installation](#installation)
- [Usage](#usage)
- [Contributing](#contributing)
- [License](#license)

## Installation

```bash
pip install xml-generator
```

## Usage

### Import

```python
from xml_generator.types import XmlNode
```

### Comprehensive parsing

Parse Comprehensive format into an XmlNode object.

```python
node = XmlNode.parse(
    {
        "name": "node",
        "attributes": {"attr1": "value1", "attr2": "value2"},
        "body": [
            {"name": "child1", "attributes": {"attr1": "value1"}},
            {"name": "child2", "attributes": {"attr2": "value2"}},
        ],
    }
)
```

### Searching a specific node

Return the first XmlNode with the given query. Query can be a name with attributes.

```python
parent = node.find("node")
child1 = node.find("child1@attr1")
child2 = node.find("child2")
```

### Generate a xml file

Using the `to_xml()` function that return the XmlNode as an XML string.

```python
with open('sample.xml', 'w', encoding='utf-8') as f:
    f.write(node.to_xml())
```

## Contributing

Coming soon.

## License

License :: OSI Approved :: MIT License
